#include <stdlib.h>
#include <string.h>
#include "tokenizer.h"

Tokenizer createTokenizer(char fileName[], char separatorChars[])
{
    Tokenizer t;
    FILE *f = fopen(fileName, "r");
    if (f != NULL)
    {
        t = (Tokenizer)malloc(sizeof(struct TokenizerStruct));
        strcpy(t->separatorChars, separatorChars);
        t->textFile = f;        
    }
    else
    {
        t = NULL;
    }
    return t;
}

void destroyTokenizer(Tokenizer t)
{
    fclose(t->textFile);
    free(t);
}

BOOL getNextToken(Tokenizer t, char buffer[])
{
    int index;
    char c;

    //Salta i caratteri di separazione
    c = fgetc(t->textFile);
    while (c != EOF && strchr(t->separatorChars, c) != NULL)
    {
        c = fgetc(t->textFile);
    }

    //Legge una parola (il primo carattere della parola  gi stato
    //letto dal ciclo precedente)
    index = 0;
    while (c != EOF && strchr(t->separatorChars, c) == NULL)
    {
        buffer[index++] = c;
        c = fgetc(t->textFile);
    }
    buffer[index] = '\0';

    return index != 0;
}
